diff --git a/src/mainboard/emulation/qemu-q35/cmos.layout b/src/mainboard/emulation/qemu-q35/cmos.layout
index 5e5a901da0..10ff567a42 100644
--- a/src/mainboard/emulation/qemu-q35/cmos.layout
+++ b/src/mainboard/emulation/qemu-q35/cmos.layout
@@ -11,8 +11,10 @@ entries
 448	1	e	1	power_on_after_fail
 452	4	e	6	debug_level
 
+456	400	s	0	bootorder
+
 # VBOOT
-464	128	r	0	vbnv
+880	128	r	0	vbnv
 
 1008	16	h	0	check_sum
 